Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/src/Parameters_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/src/Parameters_print.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/src/Parameters_print.cpp	(revision 88)
@@ -0,0 +1,132 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/include/Parameters.h"
+#include "Behavioural/include/XML.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_ooo_engine {
+namespace ooo_engine {
+
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine::print"
+  std::string Parameters::print (uint32_t depth)
+  {
+    log_begin(OOO_Engine,FUNCTION);
+
+    std::string str = "";
+    
+    str+= toString(MSG_INFORMATION)+"   * nb_front_end                     : "+toString<uint32_t         >(_nb_front_end                     )+"\n";
+    for (uint32_t i=0; i<_nb_front_end; ++i)
+    str+= toString(MSG_INFORMATION)+"   * nb_context                         ["+toString(i)+"] : "+toString<uint32_t         >(_nb_context [i]                   )+"\n";//[nb_front_end]
+    str+= toString(MSG_INFORMATION)+"   * nb_rename_unit                   : "+toString<uint32_t         >(_nb_rename_unit                   )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * nb_execute_loop                  : "+toString<uint32_t         >(_nb_execute_loop                  )+"\n";
+    for (uint32_t i=0; i<_nb_front_end; ++i)
+    str+= toString(MSG_INFORMATION)+"   * nb_inst_decod                      ["+toString(i)+"] : "+toString<uint32_t         >(_nb_inst_decod [i]                )+"\n";//[nb_front_end]
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+    str+= toString(MSG_INFORMATION)+"   * nb_inst_insert                     ["+toString(i)+"] : "+toString<uint32_t         >(_nb_inst_insert [i]               )+"\n";//[nb_rename_unit]
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+    str+= toString(MSG_INFORMATION)+"   * nb_inst_retire                     ["+toString(i)+"] : "+toString<uint32_t         >(_nb_inst_retire [i]               )+"\n";//[nb_rename_unit]
+    str+= toString(MSG_INFORMATION)+"   * nb_inst_issue                    : "+toString<uint32_t         >(_nb_inst_issue                    )+"\n";
+    for (uint32_t i=0; i<_nb_execute_loop; ++i)
+    str+= toString(MSG_INFORMATION)+"   * nb_inst_execute                    ["+toString(i)+"] : "+toString<uint32_t         >(_nb_inst_execute [i]              )+"\n";//[nb_execute_loop]
+    str+= toString(MSG_INFORMATION)+"   * nb_inst_reexecute                : "+toString<uint32_t         >(_nb_inst_reexecute                )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * nb_inst_commit                   : "+toString<uint32_t         >(_nb_inst_commit                   )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * nb_inst_branch_complete          : "+toString<uint32_t         >(_nb_inst_branch_complete          )+"\n";
+    for (uint32_t i=0; i<_nb_front_end; ++i)
+    for (uint32_t j=0; j<_nb_context[i]; ++j)
+    str+= toString(MSG_INFORMATION)+"   * nb_branch_speculated               ["+toString(i)+"]["+toString(j)+"] : "+toString<uint32_t         >(_nb_branch_speculated [i][j]      )+"\n";//[nb_front_end][nb_context]
+    str+= toString(MSG_INFORMATION)+"   * nb_rename_unit_select            : "+toString<uint32_t         >(_nb_rename_unit_select            )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * nb_execute_loop_select           : "+toString<uint32_t         >(_nb_execute_loop_select           )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * size_general_data                : "+toString<uint32_t         >(_size_general_data                )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * size_special_data                : "+toString<uint32_t         >(_size_special_data                )+"\n";
+    for (uint32_t i=0; i<_nb_front_end; ++i)
+    str+= toString(MSG_INFORMATION)+"   * link_rename_unit_with_front_end    ["+toString(i)+"] : "+toString<uint32_t         >(_link_rename_unit_with_front_end[i])+"\n";//[nb_front_end]
+    str+= toString(MSG_INFORMATION)+"   * size_re_order_buffer             : "+toString<uint32_t         >(_size_re_order_buffer             )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * nb_re_order_buffer_bank          : "+toString<uint32_t         >(_nb_re_order_buffer_bank          )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * commit_priority                  : "+toString<Tpriority_t      >(_commit_priority                  )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * commit_load_balancing            : "+toString<Tload_balancing_t>(_commit_load_balancing            )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * size_issue_queue                 : "+toString<uint32_t         >(_size_issue_queue                 )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * nb_issue_queue_bank              : "+toString<uint32_t         >(_nb_issue_queue_bank              )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * issue_priority                   : "+toString<Tpriority_t      >(_issue_priority                   )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * issue_load_balancing             : "+toString<Tload_balancing_t>(_issue_load_balancing             )+"\n";
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+    for (uint32_t j=0; j<_nb_inst_issue ; ++j)
+    str+= toString(MSG_INFORMATION)+"   * table_routing                      ["+toString(i)+"]["+toString(j)+"] : "+toString<bool             >(_table_routing [i][j]             )+"\n";//[nb_rename_unit][nb_inst_issue]
+    for (uint32_t i=0; i<_nb_inst_issue ; ++i)
+    for (uint32_t j=0; j<_nb_type; ++j)
+    str+= toString(MSG_INFORMATION)+"   * table_issue_type                   ["+toString(i)+"]["+toString_type(j)+"] : "+toString<bool             >(_table_issue_type [i][j]          )+"\n";//[nb_inst_issue][nb_type]
+    str+= toString(MSG_INFORMATION)+"   * size_reexecute_queue             : "+toString<uint32_t         >(_size_reexecute_queue             )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * reexecute_priority               : "+toString<Tpriority_t      >(_reexecute_priority               )+"\n";
+    str+= toString(MSG_INFORMATION)+"   * reexecute_load_balancing         : "+toString<Tload_balancing_t>(_reexecute_load_balancing         )+"\n";
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+    str+= toString(MSG_INFORMATION)+"   * rename_select_priority             ["+toString(i)+"] : "+toString<Tpriority_t      >(_rename_select_priority           [i])+"\n";//[nb_rename_unit]
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+    str+= toString(MSG_INFORMATION)+"   * rename_select_load_balancing       ["+toString(i)+"] : "+toString<Tload_balancing_t>(_rename_select_load_balancing     [i])+"\n";//[nb_rename_unit]
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+    str+= toString(MSG_INFORMATION)+"   * rename_select_nb_front_end_select  ["+toString(i)+"] : "+toString<uint32_t         >(_rename_select_nb_front_end_select[i])+"\n";//[nb_rename_unit]
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+    str+= toString(MSG_INFORMATION)+"   * nb_general_register                ["+toString(i)+"] : "+toString<uint32_t         >(_nb_general_register              [i])+"\n";//[nb_rename_unit]
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+    str+= toString(MSG_INFORMATION)+"   * nb_special_register                ["+toString(i)+"] : "+toString<uint32_t         >(_nb_special_register              [i])+"\n";//[nb_rename_unit]
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+    str+= toString(MSG_INFORMATION)+"   * nb_reg_free                        ["+toString(i)+"] : "+toString<uint32_t         >(_nb_reg_free                      [i])+"\n";//[nb_rename_unit]
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+    str+= toString(MSG_INFORMATION)+"   * nb_rename_unit_bank                ["+toString(i)+"] : "+toString<uint32_t         >(_nb_rename_unit_bank              [i])+"\n";//[nb_rename_unit]
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+    str+= toString(MSG_INFORMATION)+"   * size_read_counter                  ["+toString(i)+"] : "+toString<uint32_t         >(_size_read_counter                [i])+"\n";//[nb_rename_unit]
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+    str+= toString(MSG_INFORMATION)+"   * nb_load_store_queue                ["+toString(i)+"] : "+toString<uint32_t         >(_nb_load_store_queue              [i])+"\n";//[nb_rename_unit]
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+    for (uint32_t j=0; j<_nb_load_store_queue[i]; ++j)
+    str+= toString(MSG_INFORMATION)+"   * size_store_queue                   ["+toString(i)+"]["+toString(j)+"] : "+toString<uint32_t         >(_size_store_queue                 [i][j])+"\n";//[nb_rename_unit][nb_load_store_queue]
+    for (uint32_t i=0; i<_nb_rename_unit; ++i)
+    for (uint32_t j=0; j<_nb_load_store_queue[i]; ++j)
+    str+= toString(MSG_INFORMATION)+"   * size_load_queue                    ["+toString(i)+"]["+toString(j)+"] : "+toString<uint32_t         >(_size_load_queue                  [i][j])+"\n";//[nb_rename_unit][nb_load_store_queue]
+    for (uint32_t i=0; i<_nb_front_end; ++i)
+    for (uint32_t j=0; j<_nb_context[i]; ++j)
+    str+= toString(MSG_INFORMATION)+"   * link_load_store_unit_with_thread   ["+toString(i)+"]["+toString(j)+"] : "+toString<uint32_t         >(_link_load_store_unit_with_thread [i][j])+"\n";//[nb_front_end][nb_context]
+    for (uint32_t i=0; i<_nb_front_end; ++i)
+    for (uint32_t j=0; j<_nb_context[i]; ++j)
+    for (uint32_t k=0; k<NB_GROUP; ++k)
+    str+= toString(MSG_INFORMATION)+"   * implement_group                    ["+toString(i)+"]["+toString(j)+"]["+toString(k)+"] : "+toString<bool             >(_implement_group                  [i][j][k])+"\n";//[nb_front_end][nb_context][NB_GROUP]
+
+//     XML xml ("ooo_engine");
+
+//     xml.balise_open("ooo_engine");
+// //  xml.singleton_begin(""); xml.attribut("value",toString(_)); xml.singleton_end();
+//     xml.balise_close();
+
+    log_end(OOO_Engine,FUNCTION);
+    
+//     return xml.get_body(depth);
+    return str;
+  };
+
+#undef  FUNCTION
+#define FUNCTION "OOO_Engine::operator<<"
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::core::multi_ooo_engine::ooo_engine::Parameters & x)
+  {
+    log_begin(OOO_Engine,FUNCTION);
+
+    output_stream << x.print(0);
+    
+    log_end(OOO_Engine,FUNCTION);
+
+    return output_stream;
+  };
+
+}; // end namespace ooo_engine
+}; // end namespace multi_ooo_engine
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/Makefile	(revision 88)
@@ -0,0 +1,32 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+LIBRARY				= $(Core_LIBRARY)
+
+DIR_LIBRARY			= $(Core_DIR_LIBRARY)
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_selftest
+
+library				: Core_library
+
+library_clean			: Core_library_clean
+
+local_clean			:
+
+include                         $(DIR_COMPONENT)/Makefile.deps
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Selftest
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.Synthesis
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/config-min.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/config-min.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/config-min.cfg	(revision 88)
@@ -0,0 +1,133 @@
+Core
+32	32	+1	# size_general_data                                                                    
+2	2	+1	# size_special_data                                                                    
+1	1	+1	# nb_thread                                                                            
+1	1	+1	# size_ifetch_queue                       [0]       [nb_thread]                                  
+1	1	+1	# nb_inst_fetch                           [0]       [nb_thread]                                  
+2	2	+1	# ras_size_queue                          [0]       [nb_thread]                                  
+1	1	+1	# upt_size_queue                          [0]       [nb_thread]                                  
+1	1	+1	# nb_decod_bloc                                                                           
+1	1	+1	# size_decod_queue                        [0]       [nb_decod_bloc]                              
+1	1	+1	# nb_inst_decod                           [0]       [nb_decod_bloc]                              
+1	1	+1	# nb_context_select                       [0]       [nb_decod_bloc]                              
+1	1	+1	# context_select_priority                 [0]       [nb_decod_bloc]                              
+1	1	+1	# context_select_load_balancing           [0]       [nb_decod_bloc]                              
+1	1	+1	# nb_rename_bloc                                                                          
+1	1	+1	# nb_inst_insert                          [0]       [nb_rename_bloc]
+1	1	+1	# nb_inst_retire                          [0]       [nb_rename_bloc]
+1	1	+1	# rename_select_priority                  [0]       [nb_rename_bloc]                             
+1	1	+1	# rename_select_load_balancing            [0]       [nb_rename_bloc]                             
+1	1	+1	# rename_select_nb_front_end_select       [0]       [nb_rename_bloc]                             
+64	64	+1	# nb_general_register                     [0]       [nb_rename_bloc]                             
+4	4	+1	# nb_special_register                     [0]       [nb_rename_bloc]                             
+1	1	+1	# nb_reg_free                             [0]       [nb_rename_bloc]                             
+1	1	+1	# nb_rename_unit_bank                     [0]       [nb_rename_bloc]                             
+1	1	+1	# size_read_counter                       [0]       [nb_rename_bloc]                             
+1	1	+1	# nb_read_bloc                                                                            
+1	1	+1	# size_read_queue                         [0]       [nb_read_bloc]                               
+1	1	+1	# size_reservation_station                [0]       [nb_read_bloc]                               
+1	1	+1	# nb_inst_retire_reservation_station      [0]       [nb_read_bloc]                               
+1	1	+1	# nb_write_bloc                                                                           
+1	1	+1	# size_write_queue                        [0]       [nb_write_bloc]                              
+1	1	+1	# size_execute_queue                      [0]       [nb_write_bloc]                              
+0	0	+1	# nb_bypass_write                         [0]       [nb_write_bloc]                              
+1	1	+1	# nb_load_store_unit                                                                      
+2	2	+1	# size_store_queue                        [0]       [nb_load_store_unit]                         
+1	1	+1	# size_load_queue                         [0]       [nb_load_store_unit]                         
+1	1	+1	# size_speculative_access_queue           [0]       [nb_load_store_unit]                         
+1	1	+1	# nb_port_check                           [0]       [nb_load_store_unit]                         
+2	2	+1	# speculative_load                        [0]       [nb_load_store_unit]                         
+0	0	+1	# nb_bypass_memory                        [0]       [nb_load_store_unit]                         
+1	1	+1	# nb_cache_port                           [0]       [nb_load_store_unit]                         
+1	1	+1	# nb_inst_memory                          [0]       [nb_load_store_unit]                         
+1	1	+1	# nb_functionnal_unit                                                                     
+1	1	+1	# nb_inst_functionnal_unit                [0]       [nb_functionnal_unit]                        
+1	1	+1	# nb_icache_port                                                                          
+1	1	+1	# icache_access_priority                                                                  
+1	1	+1	# icache_access_load_balancing                                                            
+1	1	+1	# nb_dcache_port                                                                          
+1	1	+1	# dcache_access_priority                                                                  
+1	1	+1	# dcache_access_load_balancing                                                            
+1	1	+1	# nb_front_end                                                                            
+1	1	+1	# nb_context                              [0]       [nb_front_end]                               
+1	1	+1	# nb_decod_unit                           [0]       [nb_front_end]                               
+1	1	+1	# nb_inst_branch_predict                  [0]       [nb_front_end]                               
+1	1	+1	# nb_inst_branch_decod                    [0]       [nb_front_end]                               
+1	1	+1	# nb_inst_branch_update                   [0]       [nb_front_end]                               
+1	1	+1	# btb_size_queue                          [0]       [nb_front_end]                               
+1	1	+1	# btb_associativity                       [0]       [nb_front_end]                               
+2	2	+1	# btb_size_counter                        [0]       [nb_front_end]                               
+1	1	+1	# btb_victim_scheme                       [0]       [nb_front_end]                               
+1	1	+1	# dir_predictor_scheme                    [0]       [nb_front_end]                               
+1	1	+1	# dir_have_bht                            [0][0]    [nb_front_end][3]                            
+1	1	+1	# dir_have_bht                            [0][1]    [nb_front_end][3]                            
+1	1	+1	# dir_have_bht                            [0][2]    [nb_front_end][3]                            
+1	1	+1	# dir_bht_size_shifter                    [0][0]    [nb_front_end][3]                            
+1	1	+1	# dir_bht_size_shifter                    [0][1]    [nb_front_end][3]                            
+1	1	+1	# dir_bht_size_shifter                    [0][2]    [nb_front_end][3]                            
+1	1	+1	# dir_bht_nb_shifter                      [0][0]    [nb_front_end][3]                            
+1	1	+1	# dir_bht_nb_shifter                      [0][1]    [nb_front_end][3]                            
+1	1	+1	# dir_bht_nb_shifter                      [0][2]    [nb_front_end][3]                            
+1	1	+1	# dir_have_pht                            [0][0]    [nb_front_end][3]                            
+1	1	+1	# dir_have_pht                            [0][1]    [nb_front_end][3]                            
+1	1	+1	# dir_have_pht                            [0][2]    [nb_front_end][3]                            
+1	1	+1	# dir_pht_size_counter                    [0][0]    [nb_front_end][3]                            
+1	1	+1	# dir_pht_size_counter                    [0][1]    [nb_front_end][3]                            
+1	1	+1	# dir_pht_size_counter                    [0][2]    [nb_front_end][3]                            
+1	1	+1	# dir_pht_nb_counter                      [0][0]    [nb_front_end][3]                            
+1	1	+1	# dir_pht_nb_counter                      [0][1]    [nb_front_end][3]                            
+1	1	+1	# dir_pht_nb_counter                      [0][2]    [nb_front_end][3]                            
+1	1	+1	# dir_pht_size_address_share              [0][0]    [nb_front_end][3]                            
+1	1	+1	# dir_pht_size_address_share              [0][1]    [nb_front_end][3]                            
+1	1	+1	# dir_pht_size_address_share              [0][2]    [nb_front_end][3]                            
+1	1	+1	# nb_ooo_engine                                                                           
+1	1	+1	# nb_rename_unit                          [0]       [nb_ooo_engine]                              
+1	1	+1	# nb_inst_issue                           [0]       [nb_ooo_engine]                              
+1	1	+1	# nb_inst_reexecute                       [0]       [nb_ooo_engine]                              
+1	1	+1	# nb_inst_commit                          [0]       [nb_ooo_engine]                              
+1	1	+1	# nb_inst_branch_complete                 [0]       [nb_ooo_engine]                              
+1	1	+1	# nb_rename_unit_select                   [0]       [nb_ooo_engine]                              
+1	1	+1	# nb_execute_loop_select                  [0]       [nb_ooo_engine]                              
+1	1	+1	# size_re_order_buffer                    [0]       [nb_ooo_engine]                              
+1	1	+1	# nb_re_order_buffer_bank                 [0]       [nb_ooo_engine]                              
+1	1	+1	# commit_priority                         [0]       [nb_ooo_engine]                              
+1	1	+1	# commit_load_balancing                   [0]       [nb_ooo_engine]                              
+1	1	+1	# size_issue_queue                        [0]       [nb_ooo_engine]                              
+1	1	+1	# nb_issue_queue_bank                     [0]       [nb_ooo_engine]                              
+1	1	+1	# issue_priority                          [0]       [nb_ooo_engine]                              
+1	1	+1	# issue_load_balancing                    [0]       [nb_ooo_engine]                              
+1	1	+1	# size_reexecute_queue                    [0]       [nb_ooo_engine]                              
+1	1	+1	# reexecute_priority                      [0]       [nb_ooo_engine]                              
+1	1	+1	# reexecute_load_balancing                [0]       [nb_ooo_engine]                              
+1	1	+1	# nb_execute_loop                                                                         
+1	1	+1	# nb_read_unit                            [0]       [nb_execute_loop]                            
+2	2	+1	# nb_execute_unit                         [0]       [nb_execute_loop]                            
+1	1	+1	# nb_write_unit                           [0]       [nb_execute_loop]                            
+1	1	+1	# nb_gpr_bank                             [0]       [nb_execute_loop]                            
+1	1	+1	# nb_gpr_port_read_by_bank                [0]       [nb_execute_loop]                            
+1	1	+1	# nb_gpr_port_write_by_bank               [0]       [nb_execute_loop]                            
+1	1	+1	# nb_spr_bank                             [0]       [nb_execute_loop]                            
+1	1	+1	# nb_spr_port_read_by_bank                [0]       [nb_execute_loop]                            
+1	1	+1	# nb_spr_port_write_by_bank               [0]       [nb_execute_loop]                            
+1	1	+1	# execution_unit_to_write_unit_priority   [0]       [nb_execute_loop]                            
+1	1	+1	# read_unit_to_execution_unit_priority    [0]       [nb_execute_loop]                            
+0	0	+1	# link_context_with_thread                [0]       [nb_thread]                                  
+0	0	+1	# link_decod_unit_with_decod_bloc         [0]       [nb_decod_bloc]                              
+0	0	+1	# link_rename_unit_with_rename_bloc       [0]       [nb_rename_bloc]                             
+0	0	+1	# link_read_unit_with_read_bloc           [0]       [nb_read_bloc]                               
+0	0	+1	# link_write_unit_with_write_bloc         [0]       [nb_write_bloc]                              
+0	0	+1	# link_execute_unit_with_functionnal_unit [0]       [nb_functionnal_unit]                        
+1	1	+1	# link_execute_unit_with_load_store_unit  [0]       [nb_load_store_unit]                         
+0	0	+1	# link_decod_bloc_with_thread             [0]       [nb_thread]                                  
+0	0	+1	# link_rename_bloc_with_front_end         [0]       [nb_front_end]                               
+1	1	+1	# table_dispatch                          [0][0][0] [nb_ooo_engine][nb_inst_issue][nb_read_bloc] 
+1	1	+1	# link_read_bloc_and_load_store_unit      [0][0]    [nb_read_bloc][nb_load_store_unit]           
+1	1	+1	# link_read_bloc_and_functionnal_unit     [0][0]    [nb_read_bloc][nb_functionnal_unit]          
+1	1	+1	# link_write_bloc_and_load_store_unit     [0][0]    [nb_write_bloc][nb_load_store_unit]          
+1	1	+1	# link_write_bloc_and_functionnal_unit    [0][0]    [nb_write_bloc][nb_functionnal_unit]         
+0	0	+1	# link_load_store_unit_with_thread        [0]       [nb_thread]                                  
+1	1	+1	# link_thread_and_functionnal_unit        [0][0]    [nb_thread][nb_functionnal_unit]             
+0	0	+1	# link_icache_port_with_thread            [0]       [nb_thread]                                  
+0	0	+1	# link_dcache_port_with_load_store_unit   [0][0]    [nb_load_store_unit][nb_cache_port]          
+1	1	+1	# dispatch_priority                                                                    
+1	1	+1	# dispatch_load_balancing                                                              
